# Package

version       = "0.1.0"
author        = "prod2"
description   = "A simple scripting language."
license       = "Apache-2.0"
srcDir        = "src"
skipDirs      = @["tests", "examples"]
binDir        = "bin"
installExt    = @["nim"]
bin           = @["nds"]

# Dependencies

requires "nim >= 1.6.2"

task test, "run tests":
  exec "nim c --gc:arc -d:release --skipProjCfg --skipParentCfg --out:bin/nds src/nds.nim"
  exec "nim c --gc:arc -d:debug --skipProjCfg --skipParentCfg -r tests/test.nim"
  exec "rm tests/test"

task debug, "build nds for debugging":
  exec "nim c --gc:arc -d:debug --skipProjCfg --skipParentCfg --out:bin/nds src/nds.nim"

task danger, "build nds with -d:danger":
  exec "nim c --gc:arc -d:danger --skipProjCfg --skipParentCfg --out:bin/nds src/nds.nim"

task profile, "build nds with internal profiler":
  exec "nim c --gc:arc -d:danger -d:ndsprofile --skipProjCfg --skipParentCfg --out:bin/nds src/nds.nim"